﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using DmisLib.Utilities;

namespace DmisLib.Dmis
{
    public class DmisFolder : StandardFolder
    {
        public DmisFolder(String path): base(path)
        {
        }

        /// <summary>
        /// Returns a list of dmi filenames without DMI extension.
        /// </summary>
        public String[] DmisList
        {
            get
            {
                String[] p1List = getFilesByRegExp("*.DMI");
                String[] dmisNames = new String[p1List.Count()];

                int i = 0;
                foreach (String pname in p1List)
                {
                    dmisNames[i] = StringTransforms.stripExtension(".DMI", pname);
                    i++;
                }

                return dmisNames;
            }
        }
    }
}
