﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DmisLib.Session
{
    public class DimensionData
    {
        public String Id { set; get; }
        public Int32 IdIndex { set; get; }
        public String Feature { set; get; }
        public Int32 FeatIndex { set; get; }
        public String DimensionType {set; get;}
        public String TimeStamp { set; get; }
        public String Axis {set; get;}
        public Double Nominal {set; get;}
        public Double Measured {set; get;}
        public Double PlusTol {set; get;}
        public Double MinusTol { set; get;}
        public Double Deviation {set; get;}
        public Double OutTol {set; get;}

        public DimensionData(String id)
        {
            // Init all parameters of the data to a known state.
            Id = id;
            IdIndex = 0;
            Feature = "";
            FeatIndex = 0;
            DimensionType = "";
            TimeStamp = "";
            Axis = "";
            Nominal = 0.0;
            Measured = 0.0;
            PlusTol = 0.0;
            MinusTol = 0.0;
            Deviation = 0.0;
            OutTol = 0.0;
        }

        public DimensionData(String id, Int32 iIndex, String feature, Int32 fIndex)
        {
            Id = id;
            IdIndex = iIndex;
            Feature = feature;
            FeatIndex = fIndex;
        }

        public String Status
        {
            get
            {
                if (OutTol != 0)
                {
                    return "KO";
                }
                else
                {
                    return "OK";
                }
            }
        }
    }
}
