﻿using System;

namespace DmisLib.Geometry
{
    public class VectorPoint
    {
        private double vecScaleFactor = 1;
        private int seqNum = 0;
        private string vecPntLabel = "";
        private double xVal = 0;
        private double yVal = 0;
        private double zVal = 0;
        private double iVal = 0;
        private double jVal = 0;
        private double kVal = 0;
        private int vecDir = 1;

        public VectorPoint(int pntNum, string label)
        {
            PntSeqNumber = pntNum;
            PntLabel = label;
        }

        public VectorPoint(int pntNum,
                            string label,
                            double Xvalue,
                            double Yvalue,
                            double Zvalue,
                            double Ivalue,
                            double Jvalue,
                            double Kvalue)
        {
            PntSeqNumber = pntNum;
            PntLabel = label;
            xVal = Xvalue;
            yVal = Yvalue;
            zVal = Zvalue;
            iVal = Ivalue;
            jVal = Jvalue;
            kVal = Kvalue;
        }

        public double ScaleFactor
        {
            set { vecScaleFactor = value; }
            get { return vecScaleFactor; }
        }

        public int PntSeqNumber
        {
            set { seqNum = value; }
            get { return seqNum; }
        }

        public string PntLabel
        {
            set { vecPntLabel = value; }
            get { return vecPntLabel; }
        }

        public double X
        {
            set { xVal = value; }
            get { return xVal * vecScaleFactor; }
        }

        public double Y
        {
            set { yVal = value; }
            get { return yVal * vecScaleFactor; }
        }

        public double Z
        {
            set { zVal = value; }
            get { return zVal * vecScaleFactor; }
        }

        public double I
        {
            set { iVal = value; }
            get { return iVal * vecDir; }
        }

        public double J
        {
            set { jVal = value; }
            get { return jVal * vecDir; }
        }
        public double K
        {
            set { kVal = value; }
            get { return kVal * vecDir; }
        }

        public bool VectorNormal
        {
            set
            {
                if (value == true)
                {
                    vecDir = 1;
                }
                else
                {
                    vecDir = -1;
                }
            }
            get
            {
                if (vecDir == 1)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        public override string ToString()
        {
            return String.Format("{0:F0}", PntSeqNumber) + "," +
                                PntLabel + "," +
                                String.Format("{0:F4}", X) + "," +
                                String.Format("{0:F4}", Y) + "," +
                                String.Format("{0:F4}", Z) + "," +
                                String.Format("{0:F4}", I) + "," +
                                String.Format("{0:F4}", J) + "," +
                                String.Format("{0:F4}", K);
        }

    }
}
